package notificationhelper

import (
	"net/http"
	"net/url"

	"corelab.mkcl.org/MKCLOS/coredevelopmentplatform/coreospackage/confighelper"
)

type SMS struct {
	MobileNumber string
	Message      string
	UserName     string
	Password     string
	SenderID     string
	CDMAHeader   string
}

// SendSMS : send SMS Service
func SendSMS(smsObject SMS) error {
	var postURL string
	postURL = confighelper.GetConfig("SMSAPIURL") + "?UserName=" + smsObject.UserName + "&password=" + smsObject.Password + "&MobileNo=" + smsObject.MobileNumber + "&SenderID=" + smsObject.SenderID + "&CDMAHeader=" + smsObject.CDMAHeader + "&Message=" + url.QueryEscape(smsObject.Message)

	resp, err := http.Get(postURL)
	if err != nil {
		return err
	}
	defer resp.Body.Close()
	// body, err := ioutil.ReadAll(resp.Body)
	// if err != nil {
	// 	return err
	// }

	return nil
}

// GetSMSObject : get sms object
func GetSMSObject() SMS {
	var smsObject = new(SMS)
	smsObject.SenderID = "MKCLTD"
	smsObject.UserName = "solar1_trans"
	smsObject.Password = "trans123"
	smsObject.CDMAHeader = "MKCLTD"
	return *smsObject
}
