package securityhelper

import "github.com/DataDog/zstd"

//Compress Compress
func Compress(inputData []byte) ([]byte, error) {
	compressedData, err := zstd.CompressLevel(nil, inputData, 9)
	return compressedData, err
}

// Decompress  Decompress
func Decompress(compressedData []byte) ([]byte, error) {
	decompressedData, err := zstd.Decompress(nil, compressedData)
	return decompressedData, err
}
